module cantor2 where

  data Empty : Set where

  data One : Set where
    one : One

  data coprod (A : Set1) (B : Set1) : Set1 where
    inl : ∀ (a : A) -> coprod A B
    inr : ∀ (b : B) -> coprod A B

  postulate em : ∀ (A : Set1) -> coprod A (A -> Empty)

  data Eq1 {A : Set1} (x : A) : A -> Set1 where
    refl : Eq1 x x

  data I : (Set -> Set) -> Set where

  data invI (a : Set) : Set1 where
    inv : forall x -> (Eq1 (I x) a) -> invI a

  cantor : Set -> Set
  cantor a with em (invI a)
  cantor .(I x) | inl (inv x refl) = x (I x) -> Empty
  cantor a | inr b = One

{- 
mutual
  cantor : Set -> Set
  cantor a = cantor_aux a (em (invI a))

  cantor_aux : (a : Set) -> coprod (invI a) (invI a -> Empty) -> Set
  cantor_aux .(I x) (inl (inv x refl)) = x (I x) -> Empty
  cantor_aux a      (inr b) = One
-}

  CANTOR : Set
  CANTOR = I cantor

{-
mutual 
  no : cantor CANTOR -> Empty
  no p = no_aux (em (invI CANTOR)) p
  
  no_aux : (z : coprod (invI CANTOR) (invI CANTOR -> Empty)) 
           (p : cantor_aux CANTOR z) -> Empty
  no_aux (inl (inv .cantor refl)) p = p { p : cantor (I cantor) -> Empty }0
-}

  no : cantor CANTOR -> Empty
  no p with em (invI CANTOR)
  no p | inl (inv .cantor refl) = p {! p!} 
{- AGDA SAYS:
  p : (cantor (I cantor) | em (invI (I cantor)) → Empty)
-}
  no p | inr b = b (inv cantor refl)

  yes : cantor CANTOR
  yes with em (invI CANTOR)
  yes | inl (inv .cantor refl) = no -- λ p -> p p 
  yes | inr b = one

  Ω : Empty
  Ω = no yes
