module cantor5 where

  data Empty : Set where

  data One : Set where
    one : One

  data coprod (A : Set1) (B : Set1) : Set1 where
    inl : ∀ (a : A) -> coprod A B
    inr : ∀ (b : B) -> coprod A B

  postulate exmid : ∀ (A : Set1) -> coprod A (A -> Empty)

  data Eq1 {A : Set1} (x : A) : A -> Set1 where
    refleq1 : Eq1 x x

  Eq1cong : ∀ {f g : Set -> Set} a -> Eq1 f g -> Eq1 (f a) (g a)
  Eq1cong a refleq1 = refleq1

  data I : (Set -> Set) -> Set where

  Iinj : ∀ { x y : Set -> Set } -> Eq1 (I x) (I y) -> Eq1 x y
  Iinj refleq1 = refleq1

  data invimageI (a : Set) : Set1 where
    invelmtI : forall x -> (Eq1 (I x) a) -> invimageI a

  cantor : Set -> Set
  cantor a with exmid (invimageI a)
  cantor .(I x) | inl (invelmtI x refleq1) = x (I x) -> Empty
  cantor a | inr b = One

-- \a. if a = I x then ~ x a else true

  CANTOR : Set
  CANTOR = I cantor

  cast : ∀ { A B } -> Eq1 A B -> B -> A
  cast refleq1 a = a

  cast2 : ∀ { A B } -> Eq1 A B -> A -> B
  cast2 refleq1 a = a

  no : cantor (I cantor) -> Empty
  no p with exmid (invimageI (I cantor))
  no p | inl (invelmtI .cantor refleq1) = p p
  no p | inr b with b (invelmtI (I cantor) refleq1)
  no p | inr b | ()
{-
  yes : cantor CANTOR
  yes with exmid (invimageI CANTOR)
  yes | inl (invelmtI x refleq1) = λ p -> cast2 (Eq1cong CANTOR (Iinj y)) p p
  yes | inr b = one

  russell : Empty
  russell = no yes
-}